#include <string>
#include <iostream>
#include <libxml/HTMLparser.h>

void StartElement(void* voidContext, const xmlChar* name, const xmlChar** attr) {
  std::cout << "StartElement (" << name << ")" << std::endl;
}

void EndElement(void* voidContext, const xmlChar* name) { 
  std::cout << "EndElement (" << name << ")" << std::endl;
}

void Characters(void* voidContext, const xmlChar* chars, int len) {
  std::cout << "Characters: '" << chars << "', len = " << len << std::endl; 
}

htmlSAXHandler saxHandler = {
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  StartElement,
  EndElement,
  nullptr,
  Characters,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr,
  nullptr
};

void parseHTML(const std::string& html) {
  htmlParserCtxtPtr ctxt;

  ctxt = htmlCreatePushParserCtxt(&saxHandler, nullptr, "", 0, "", XML_CHAR_ENCODING_NONE);

  htmlParseChunk(ctxt, html.c_str(), html.size(), 0);
  htmlParseChunk(ctxt, "", 0, 1);

  htmlFreeParserCtxt(ctxt);
}

int main() {
  std::string html;

  
  html = "<html><head><title>Titre!</title></head><body><p>Hello</p><p style='vicious'>Hi!</p></body></html>";

  parseHTML(html);
}
