#include <iostream>
#include <string>

#include <curl/curl.h>

static char errorBuffer[CURL_ERROR_SIZE];
static std::string buffer;

static int writer(char* data, size_t size, size_t nmemb, std::string* writerData) {
  if (writerData == nullptr) {
    return 0;
  }
  else {
    writerData->append(data, size * nmemb);
    return size * nmemb;
  }
}

std::string getWebpage(std::string& url) {
  curl_global_init(CURL_GLOBAL_DEFAULT);

  CURL*    conn = curl_easy_init();
  CURLcode code;

  code = curl_easy_setopt(conn, CURLOPT_ERRORBUFFER, errorBuffer);
  code = curl_easy_setopt(conn, CURLOPT_URL, url.c_str());
  code = curl_easy_setopt(conn, CURLOPT_FOLLOWLOCATION, 1L);
  code = curl_easy_setopt(conn, CURLOPT_WRITEFUNCTION, writer);
  code = curl_easy_setopt(conn, CURLOPT_WRITEDATA, &buffer);

  code = curl_easy_perform(conn);

  curl_easy_cleanup(conn);

  return buffer;
}
